// $Id: AbstractTestAnalyzer.java 20106 2010-08-04 06:31:38Z stliu $
package org.hibernate.search.test.analyzer;

import java.io.IOException;
import java.io.Reader;

import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.Token;
import org.apache.lucene.analysis.TokenStream;


/**
 * @author Emmanuel Bernard
 */
public abstract class AbstractTestAnalyzer extends Analyzer {

	protected abstract String[] getTokens();

	public TokenStream tokenStream(String fieldName, Reader reader) {
		return new InternalTokenStream();
	}

	private class InternalTokenStream extends TokenStream {
		private int position;

		public Token next(final Token reusableToken) throws IOException {
			assert reusableToken != null;
			if ( position >= getTokens().length ) {
				return null;
			}
			else {
				reusableToken.clear();
				reusableToken.setTermBuffer( getTokens()[position++] );
				reusableToken.setStartOffset( 0 );
				reusableToken.setEndOffset( 0 );
				return reusableToken;
			}
		}
	}
}
